"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyleCopyConfig = exports.CopyConfig = void 0;
var _react = _interopRequireWildcard(require("react"));
var _components = require("@kepler.gl/components");
var _schemas = require("@kepler.gl/schemas");
var _reducers = require("@kepler.gl/reducers");
var _reactCopyToClipboard = require("react-copy-to-clipboard");
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _templateObject; // SPDX-License-Identifier: MIT
// Copyright contributors to the kepler.gl project
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _taggedTemplateLiteral(e, t) { return t || (t = e.slice(0)), Object.freeze(Object.defineProperties(e, { raw: { value: Object.freeze(t) } })); }
var Params = {
  "true": 'True',
  "false": 'False',
  "null": 'None'
};
var StyleCopyConfig = exports.StyleCopyConfig = _styledComponents["default"].div.attrs({
  className: 'copy-config'
})(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  width: 100%;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  .copy-button {\n    position: absolute;\n    margin-top: -45px;\n    right: 28px;\n  }\n  textarea {\n    overflow-y: scroll;\n    white-space: pre-wrap;\n    width: 100%;\n    height: 100%;\n    resize: none;\n  }\n"])));

// convert config from string to pything dictionary
function configStringify(config) {
  // replace true => True; false => False; null => None
  var configStr = JSON.stringify(config, null, 2);
  return configStr.replace(/: ([a-z]+)/g, function (_, key) {
    return ': ' + Params[key] || ': ' + key;
  });
}
var CopyConfig = exports.CopyConfig = function CopyConfig(_ref) {
  var config = _ref.config;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    copied = _useState2[0],
    setCopy = _useState2[1];
  var value = configStringify(config);
  return /*#__PURE__*/_react["default"].createElement(StyleCopyConfig, null, /*#__PURE__*/_react["default"].createElement(_reactCopyToClipboard.CopyToClipboard, {
    text: value,
    onCopy: function onCopy() {
      return setCopy(true);
    },
    className: "copy-button"
  }, /*#__PURE__*/_react["default"].createElement(_components.Button, {
    width: "100px"
  }, /*#__PURE__*/_react["default"].createElement(_components.Icons.Clipboard, {
    height: "16px"
  }), copied ? 'Copied!' : 'Copy')), /*#__PURE__*/_react["default"].createElement(_components.TextArea, {
    value: value,
    readOnly: true,
    selected: true
  }));
};
function CustomSidePanelsFactory() {
  var CustomPanels = function CustomPanels(_ref2) {
    var activeSidePanel = _ref2.activeSidePanel,
      visState = _ref2.visState,
      mapState = _ref2.mapState,
      mapStyle = _ref2.mapStyle;
    var config = _schemas.KeplerGlSchema.getConfigToSave({
      visState: visState,
      mapState: mapState,
      mapStyle: mapStyle
    });
    if (activeSidePanel === 'config') {
      return /*#__PURE__*/_react["default"].createElement(CopyConfig, {
        config: config
      });
    }
    return null;
  };
  CustomPanels.defaultProps = {
    panels: [{
      id: 'config',
      label: 'Config',
      iconComponent: _components.Icons.CodeAlt
    }]
  };
  var ConnectedCustomPanels = (0, _components.withState)([_reducers.visStateLens, _reducers.mapStateLens, _reducers.mapStyleLens], function (state) {
    return state;
  })(CustomPanels);
  ConnectedCustomPanels.defaultProps = {
    panels: [{
      id: 'config',
      label: 'modal.exportMap.json.configTitle',
      iconComponent: _components.Icons.CodeAlt
    }]
  };
  return ConnectedCustomPanels;
}
var _default = exports["default"] = CustomSidePanelsFactory;