"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomPanelHeaderFactory = CustomPanelHeaderFactory;
exports["default"] = void 0;
var _components = require("@kepler.gl/components");
var _actions = require("@kepler.gl/actions");
var _react = _interopRequireDefault(require("react"));
var _reactIntl = require("react-intl");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); } // SPDX-License-Identifier: MIT
// Copyright contributors to the kepler.gl project
var KEPLER_DOC = 'https://docs.kepler.gl/docs/keplergl-jupyter';
function CustomPanelHeaderFactory() {
  var PanelHeader = (0, _components.PanelHeaderFactory)();
  var actionItems = function actionItems(props) {
    return [{
      id: 'docs',
      iconComponent: _components.Icons.Docs,
      href: KEPLER_DOC,
      blank: true,
      tooltip: 'tooltip.documentation',
      onClick: function onClick() {}
    }];
  };
  var JupyterPanelHeader = function JupyterPanelHeader(props) {
    return /*#__PURE__*/_react["default"].createElement(_reactIntl.IntlProvider, {
      locale: "en",
      messages: {
        'tooltip.documentation': 'Documentation'
      }
    }, /*#__PURE__*/_react["default"].createElement(PanelHeader, _extends({}, props, {
      actionItems: actionItems(props)
    })));
  };
  return (0, _components.withState)([], function (state) {
    return state;
  }, {
    toggleModal: _actions.toggleModal
  })(JupyterPanelHeader);
}
var _default = exports["default"] = CustomPanelHeaderFactory;