"use strict";

var _store = _interopRequireDefault(require("./store"));
var _root = _interopRequireDefault(require("./components/root"));
var _document = _interopRequireDefault(require("global/document"));
var _window = _interopRequireDefault(require("global/window"));
var _kepler = require("./kepler.gl");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
// SPDX-License-Identifier: MIT
// Copyright contributors to the kepler.gl project

// NOTE: this is only used for exporting html template

var map = function initKeplerGl() {
  var id = 'keplergl-0';
  var store = (0, _store["default"])();
  var divElmt = _document["default"].createElement('div');
  divElmt.setAttribute('style', 'width: 100vw; height: 100vh; position: absolute');
  _document["default"].body.appendChild(divElmt);
  return {
    render: function render() {
      (0, _root["default"])({
        id: id,
        store: store,
        ele: divElmt
      });
    },
    store: store
  };
}();
map.render();
(function loadDataConfig(keplerGlMap) {
  var _ref = _window["default"].__keplerglDataConfig || {},
    data = _ref.data,
    config = _ref.config,
    options = _ref.options;
  (0, _kepler.addDataConfigToKeplerGl)({
    data: data,
    config: config,
    options: options,
    store: keplerGlMap.store
  });
})(map);