"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _redux = require("redux");
var _reducers = require("@kepler.gl/reducers");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; } // SPDX-License-Identifier: MIT
// Copyright contributors to the kepler.gl project
var customizedKeplerGlReducer = _reducers.keplerGlReducer.initialState({
  uiState: {
    currentModal: null,
    activeSidePanel: null
  }
});
var reducers = (0, _redux.combineReducers)({
  // mount keplerGl reducer
  keplerGl: customizedKeplerGlReducer
});
var createAppStore = function createAppStore(onChangeHandler) {
  var updatesMiddleware = function updatesMiddleware(store) {
    return function (next) {
      return function (action) {
        // exclude some actions
        // Call the next dispatch method in the middleware chain.

        /* eslint-disable callback-return */
        var returnValue = next(action);
        /* eslint-enable callback-return */

        // state after dispatch
        if (typeof onChangeHandler === 'function') {
          onChangeHandler(action, store);
        }

        // This will likely be the action itself, unless
        // a middleware further in chain changed it.
        return returnValue;
      };
    };
  };
  var middlewares = (0, _reducers.enhanceReduxMiddleware)([updatesMiddleware]);
  var enhancers = [_redux.applyMiddleware.apply(void 0, _toConsumableArray(middlewares))];
  var store = (0, _redux.createStore)(reducers, {}, _redux.compose.apply(void 0, enhancers));
  return store;
};
var _default = exports["default"] = createAppStore;